* 11, 18 Feb 02:  analyse results
      program ana
      implicit none
      integer maxn, maxlen
      parameter (maxn = 20, maxlen = 50)
      integer n, twon, sum(maxlen), term(maxlen)
      integer i, j, ii, big
      real*8 time, ttime
      logical used(0:1023)
      data used/1024 * .false./

      n = 20
      twon = 2*n
      do i = 1, maxlen
         sum(i) = 0
      end do
      
      ttime = 0
      do i = 0, 1023
         read(*,fmt=100,err=10)ii,time
 100     format(6x,i4,15x,f9.2)
         if (used(ii)) then
            print*,'case',ii,'appears more than once'
         end if
         used(ii) = .true.
         ttime = ttime + time
         read(*,fmt=200)(term(j),j=1,10)
         read(*,fmt=200)(term(j),j=11,20)
 200     format(10i6)         
         big = 20
         call add(sum,term,1,big,maxlen)
         call reduce(sum,maxlen)         
      end do

 10   do i = 0, 1023
         if (.not.used(i)) then
            print*,'case',i,'does not appear'
         end if
      end do
      
      call final(sum,maxlen,twon)
      call prnsum(n,sum,maxlen)
      print*,'Total time:',ttime

      end


      subroutine add(sum,trm,sgntrm,lentrm,maxlen)
      implicit none
      integer maxlen
      integer sum(maxlen),trm(maxlen),lentrm,sgntrm
* simple addition of TRM to SUM.  Carry-overs are sorted out
* separately.
      integer i

      do i = 1, lentrm
         sum(i) = sum(i) + sgntrm*trm(i)
      end do

      end

      
      subroutine reduce(sum,maxlen)
      implicit none
      integer maxlen
      integer sum(maxlen)
* every so often it is useful to reduce the size of the terms in SUM
      integer i, carry, temp, base
      parameter (base = 10000)

      carry = 0
      do i = 1, maxlen
         temp = sum(i) + carry
         carry = temp/base
         sum(i) = mod(temp,base)
      end do
      
      end
      

      subroutine final(sum,maxlen,twon)
      implicit none
      integer maxlen, twon
      integer sum(maxlen)
* prepare for output -- make all signs positive and divide by 2^twon
      integer i, j, temp, carry, base
      parameter (base = 10000)      

* first have reduce all terms to range -base+1 to base-1
      call reduce(sum,maxlen)
      
      carry = 0
      do i = 1, maxlen-1
         if (sum(i) .lt. 0) then
            sum(i) = sum(i) + base
            sum(i+1) = sum(i+1) - 1
         end if
      end do

* now do the divisions by 2
      do i = 1, twon
         carry = 0
         do j = maxlen, 1, -1
            temp = sum(j) + base*carry
            sum(j) = temp/2
            carry = mod(temp,2)
         end do
         if (carry.ne.0) print*, 'non-zero remainder in FINAL'
      end do

      end
      

      subroutine prnsum(n,sum,maxlen)
      implicit none
      integer n, maxlen
      integer sum(maxlen)
      
      integer i, lensum
      lensum = maxlen
      do while(sum(lensum) .eq. 0)
         lensum = lensum-1
      end do

      lensum = max(lensum,1)
      print'(a,i2,a,i4,50i1)','L(2,', n, ') = ', sum(lensum),
     &              (mod(sum(i)/1000,10),
     &               mod(sum(i)/100,10),
     &               mod(sum(i)/10,10),
     &               mod(sum(i),10), i = lensum-1, 1, -1)

      end
